#!/usr/local/bin/python3.1
# Attention: This script runs under python 3.1
# Version: 0.99 a
# Last update 03: Nov 22, 2010. 16:40 
# Last update 02: Nov 19, 2010. 16:40  Peanut Blake 
# Last update 01: Aug 12, 2010. 16:40  Peanut Blake

from xml.etree.cElementTree import ElementTree
from xml.etree.cElementTree import Element
from xml.sax.saxutils import unescape

import os
import re
import glob
import shutil
import math

global IsOverWriteFile
global PatternDefault

def initial():
	global IsOverWriteFile
	IsOverWriteFile=''
	
	global LANGUAGE_DEFAULT
	global LANGUAGE_PATTERN_DEFAULT
	
	sysmy=SystemMy()
	LANGUAGE_DEFAULT=sysmy.getLanguageDefault()
	print('\tDefault Language: ', LANGUAGE_DEFAULT)
	LANGUAGE_PATTERN_DEFAULT= sysmy.getPatternDefault()
	if (LANGUAGE_PATTERN_DEFAULT==None) or (LANGUAGE_PATTERN_DEFAULT==''):
		print('--------------------------------------------------------')
		print('\tWarning: LANGUAGE_PATTERN_DEFAULT is empty!')
		print('--------------------------------------------------------')
	
	
class FileMy:
	
	def isOverWrite(self, filename):	
		# This function is to check file operation.
		# Skip, Skip All, Overwrite, Overwrite All
		global IsOverWriteFile
		is_write_file=False
		request=''
		if ( IsOverWriteFile=='SA' ) :  #  Skip All 
			is_write_file=False
		elif ( IsOverWriteFile=='WA'): #  Overwrite All
			is_write_file=True
		elif os.path.isfile(filename) :  # check whether the file is existing.
			print("File %s already exists. Do you want to overwrite it? " % filename)
			print("S: Skip / SA: Skip All")
			print("W: Overwrite / WA: Overwrite All")
			while True:
				request=input ("Please choose (type UPPER character): ")
				request=request.strip()
				IsOverWriteFile=request
				if request == 'S':
					print("File %s is skipped." % filename)
					is_write_file=False
					break
				elif request == 'SA':
					print("All existing files will be skipped.")
					is_write_file=False
					break
				elif request == 'W':
					print("File %s will be overwritten." % filename)
					is_write_file=True
					break
				elif request == 'WA':
					print("All existing files will be overwritten.")
					is_write_file=True
					break
				else :
					print("Wrong inputs. Please type: S, SA, W or WA. Try agian.")
		else  : # file does not exist
			is_write_file=True
		return is_write_file
		
	def replaceTextFolder(self, folder_in, folder_out, str_lang=''):
		# replace text in the files
		# From: <adempiereTrl language="en_US" table="AD_Column">
		# To: <adempiereTrl language="zh_CN" table="AD_Column">
		foldermy=FolderMy()
		filelist=foldermy.getFileList2(folder_in, folder_out, 'xml')
		if str_lang=='' :
			str_lang = LANGUAGE_DEFAULT
		print('----------------------------------------------------')
		print('\tReplace language=\"en_US\" with language=\"'+str_lang +'\"')
		print('----------------------------------------------------')
		
		str_con='< *adempiereTrl '
		list_sub=['language=\"en_US\"','language=\"'+str_lang +'\"']
		textmy=TextMy()
		for [fn_in, fn_out] in filelist:
			print("  Processing file: ", textmy.getFileNameHead(fn_in, 'trl'))
			fl_in=open(fn_in, encoding='utf-8')
			fl_out=open(fn_out, mode='w', encoding='utf-8')
			i=0
			for ln_in in fl_in:
				i += 1
				if i<=30:
					if (re.search(str_con, ln_in) !=  None):
						ln_new=re.sub(list_sub[0], list_sub[1], ln_in)
						fl_out.write(ln_new)
					else:
						fl_out.write(ln_in)
				else:
					fl_out.write(ln_in)
			fl_in.close()
			fl_out.close()
		print('\tFinished!')
		print('\tTotal files processed: ', len(filelist))

class FilePO(FileMy):
	
	" PO / POT file"
	
	def _getPO_TopPos(self, file_in):
		# this function is only for _getFilePOTFormal(file_head, file_in, file_out)
		# return the top line position
		
		# within line 50
		# get 2nd msgid
		# find empty line before 2nd msgid

		ls_pattern=['^[ \t\n]*$', '^#', '^msgid', '^msgid *\"\"[ \n]*$']
		ls_count=[ [], [], [], [] ]
		fl_in=open(file_in, encoding='utf-8')
		
		icount_ln=0
		for ln_in in fl_in:
			icount_ln += 1
			if ( icount_ln >=50):
				break
			
			for j in range(len(ls_pattern)):
				if (re.search(ls_pattern[j], ln_in) !=  None):
					ls_count[j].append(icount_ln)
		fl_in.close()
		
		isError=False
		# get msgid
		if len(ls_count[2])<=1 : # msgid
			print('\tError: Only 1 msgid is found POT head!')
			isError=True
		elif ( ls_count[2][0] != ls_count[3][0] ): # msgid top
			print('\tError: Wrong format in 1st msgid of POT head!')
			isError=True
		else:
			pos_msgid_2=ls_count[2][1]
		
		# get empty line
		len_empty=len(ls_count[0])
		if len_empty<=0 : # empty
			print('\tError: No empty line is found in POT head!')
			isError = True
		elif ( not isError ):
			# backwards, find 1st empty line before msgid-2
			for i in range(len_empty-1, -1, -1):
				pos_empty=ls_count[0][i]
				if pos_empty <  pos_msgid_2:
					pos_empty_2= pos_empty
					break
		
		if isError:
			return False
		else:
			return pos_empty_2
					
	def _getPO_Upd_File(self, listMsg_Source, file_pot_source, file_po_output):
		# Update translation in PO from list_trans.po
		# listMsg_Source is an Object / Class
		print('\tProcessing:\t', file_pot_source)
		# Part 1. Open file
		try:
			filemy=FileMy()
			if filemy.isOverWrite(file_po_output):
				fl_out=open(file_po_output, mode='w', encoding='utf-8')
				
				# Part 2. Write po head
				mysys=SystemMy()
				str_head_po=mysys.getHeadPo()
				fl_out.write(str_head_po)
				fl_out.write('\n\n')
				
				listmsg=ListMsg()
				listmsg.readList_Msg(file_pot_source, 1, False) # 3 -> 1
				(ls_pot_ori, ls_pot_tra, ls_pot_sharp ) = listmsg.getList_Msg('natural')
						
				ilen=len(ls_pot_ori)
				for i in range(ilen):
					str_sharp=ls_pot_sharp[i]
					str_msgid=ls_pot_ori[i]	# natural
					str_msgstr=listMsg_Source.getStrMatch(str_msgid, 'natural')
					fl_out.write(str_sharp)
					fl_out.write(str_msgid)
					fl_out.write(str_msgstr)
					fl_out.write('\n')
					
				fl_out.close()
			
		except Exception as inst: # Check whether the file_in is existing
			print( "Unexpected error writing %s: %s" % (file_po_output, inst))
			return False

	def _getFilePOTFormal(self, file_in, file_out):
		# Get formal pot file
		# 1. Add POT standard head
		# 2. Remove original top head lines.
		# 3. Remove extra strings. e.g. #: en_US_4po/AD_Column_Trl_en_US_4po.xml:3 
	
		# Part 1: Check
		pos_file_in=self._getPO_TopPos(file_in)		
		if ( pos_file_in == False):
			print("\tSkip this file. Error found!")
			return
		# Part 1.5: read pot_remark
		file_pot_remark = FileXMLPOTRemark()
		file_pot_remark.readFile_POT_Remark()
		
		textmy=TextMy()
		v_table=textmy.getFileNameHead(file_in, 'table')
	
		# Part 2: Open file
		fl_in=open(file_in, encoding='utf-8')
		fl_out=open(file_out, mode='w', encoding='utf-8')
		
		# Part 3: read from file_head, write to: file_out
		mysystem=SystemMy()
		str_head=mysystem.getHeadPot()
		fl_out.write(str_head)
		fl_out.write('\n\n')	
				
		# Part 4: read from file_in, write to: file_out
		sysmy=SystemMy()
		str_version='Version: ' +sysmy.getAdempiereVersion() + '. '
	
		str_msgid='msgid '
		str_msgstr='msgstr '
		
		_ls_msgid=[]
		
		# pay attention to the order
		list_dict=[['&lt;','<'],['&gt;','>'],['&quot;','"'], ['&apos;','\''], ['\\t','\t'], ['\\"','"'], ['\\n','\n'], ['&amp;','&']]
		
		icount_ln=0		# count
		for ln_in in fl_in:
			icount_ln +=1
			if (icount_ln>=pos_file_in):
				if (ln_in[:len(str_msgid)]==str_msgid):	# first line of msigd
					_ls_msgid = [ln_in]
				elif (ln_in[:len(str_msgstr)]==str_msgstr):	# end of msgid, first msgstr
					list_msg=ListMsg()
					txt_msgid_slim=list_msg._tidyMsg(_ls_msgid, 'slim')
					# txt_msgid_slim=unescape(txt_msgid_slim)
					for k in range(len(list_dict)):
						# print('key:\t', list_dict[k][0])
						txt_msgid_slim=txt_msgid_slim.replace(list_dict[k][0], list_dict[k][1])
						
					(v_id_column, v_pot_remark) = file_pot_remark.get_POT_Remark( v_table, txt_msgid_slim)
					
					if v_id_column=='':
						print('id_column not found. text_msgid_slim:##%s##\n' % txt_msgid_slim)
				
					v_write='#. ' + v_pot_remark + ' '+ str_version + '\n'
					fl_out.write(v_write)
					v_write='#: ' + 'Content of: ' + v_id_column + '\n'
					fl_out.write(v_write)
					for text in _ls_msgid:
						fl_out.write(text)
					fl_out.write(ln_in)	# current line of msgstr
					fl_out.write('\n')
					_ls_msgid=[]	# clean
				else:
					_ls_msgid.append(ln_in)
		
		fl_out.write('\n')	# 
		fl_out.close()
	
			
	def runPO_Upd_Folder(self, file_po_source, folder_pot, folder_po):
		# Update translation in PO from list_trans.po
		# file_po_source: list_trans_tmp.po
		
		print("-------------------------------------------------")
		print("\t list_trans_tmp.po & *.POT --> *.PO" )
		print("-------------------------------------------------")
		print("\tStep 1. Get list_trans_tmp.po as a standard source.")
		listMsg_Source=ListMsg()
		listMsg_Source.readList_Msg(file_po_source, 1, True) # 1 -> 1
		print("\tStep 1. Finished!")
		print("-------------------------------------------------")
		print("\tStep 2. Get list_trans_tmp.po as a standard source.")
		foldermy=FolderMy()
		filelist=foldermy.getFileList2(folder_pot, folder_po, 'pot2po')
		if filelist == False:
			print('\tError! Please check and try again!')
			return True
		for [file_pot, file_po] in filelist:
			self._getPO_Upd_File(listMsg_Source, file_pot, file_po)
		print("\tStep 2. Finished!")
		print("\tTotal files processed: ", len(filelist))
		print("-------------------------------------------------")

			
	def runPOT2POT(self, folder_in, folder_out):
		# "Step 2: Batch generate formal POT files" 
		foldermy=FolderMy()
		filelist=foldermy.getFileList2(folder_in, folder_out, 'pot2pot')
		if filelist == False:
			return False
			
		filepo=FilePO()
		mytext=TextMy()	
		print("-------------------------------------------------")
		print("\tBatch generate formal POT files")
		print("-------------------------------------------------")
		
		for [fn_in, fn_out] in filelist :
			print("  Processing file: ", mytext.getFileNameHead(fn_in, 'trl'))
			if filepo.isOverWrite(fn_out):
				filepo._getFilePOTFormal(fn_in, fn_out)
				
	def runPO_Merge(self, folder_po, file_po_output):
		# merge all the po files in the folder.
		# normally for po format packages downloaded from launchpad.net
		print("-------------------------------------------------")
		print("\tMerge all the PO files into ONE PO file.")
		print("-------------------------------------------------")
		foldermy=FolderMy()
		filelist=foldermy.getFileList1(folder_po, 'po')
		if filelist == False:
			print('\tError! Error is found in runPO_Merge.')
			return False
		
		listmsg=ListMsg()
		for filename in filelist:
			print('\tProcessing:\t', filename)
			# listmsg.readList_Msg(filename,  1, True)
			# change to False on Nov 21, 2010. For PO file resort
			listmsg.readList_Msg(filename,  1, False)
	
		listmsg.write(file_po_output)
		print("\tFinished!")
		print("\tTotal files processed:", len(filelist))
		print("-------------------------------------------------")
		return True
	

class FileXML():
	
		
	def tidyFile(self, file_in, file_out):
		# tidy the format of XML-AD. 
		# This function is especially for <![CDATA[&Menu]]>
		
		print("Processing file: ", file_in)
		elem_my=ElementMy()
		root_in = elem_my.getroot(file_in)
		if (elem_my.write(file_out, root_in)):
			return True
		else:
			return False
			
	def tidyFolder(self, folder_in, folder_out):
		# mark: reviewed
		print('-------------------------------------------------------')
		print('\tTidy the format of XML File by rewriting')
		print('-------------------------------------------------------')
		foldermy=FolderMy()
		filelist=foldermy.getFileList2(folder_in,folder_out, 'xml')
		
		if ( filelist == False):
			print('\tError! Error is found in getFileList2. Please check and try again!')
			return False
		
		for fl in filelist:
			self.tidyFile(fl[0], fl[1])
		
		print('\n\tFinished')
		print('\tTotal files processed: ', len(filelist))
		print('-------------------------------------------------------')
			
	def resetLanguage( folder_in, folder_out, lan_origin, lan_replace):
		# reset Language in file name & file head
		#   AD_Desktop_Trl_en_US.xml   -->   AD_Desktop_Trl_zh_CN.xml
		#   <adempiereTrl language="en_US" table="AD_Column">  -->  <adempiereTrl language="zh_CN" table="AD_Column">
		print('-------------------------------------')
		print('\tReset language')
		print('-------------------------------------')
		foldermy=FolderMy()
		filelist=foldermy.getFileList2(folder_in, folder_out, 'xml-lan', lan_origin, lan_replace )
		
		str_con='^<adempiereTrl |^<compiereTrl '
		list_sub=['language=\"' + lan_origin+ '\"','language=\"'+lan_replace +'\"']
		i_count=0
		for [fn_in, fn_out] in filelist:
			fl_in=open(fn_in, encoding='utf-8')
			fl_out=open(fn_out, mode='w', encoding='utf-8')
			i=0
			
			for ln_in in fl_in:
				i += 1
				if i<=30:
					if (re.search(str_con, ln_in) !=  None):
						ln_new=re.sub(list_sub[0], list_sub[1], ln_in)
						fl_out.write(ln_new)
						i_count += 1
					else:
						fl_out.write(ln_in)
				else:
					fl_out.write(ln_in)
			fl_in.close()
			fl_out.close()
		print('\tFinished')
		print('\tTotal files processed: ', len(filelist))
		print('\tTotal line replaced: ', i_count)
		print('-------------------------------------')
	
		
class FileXMLPOTRemark( FileXML):
	
	'''
	pot_remark.xml	
	add remarks in .pot files
	'''
	
	def getFile_POT_Remark(self, folder_in, file_out = 'pot_remark.xml'):
		# get 'pot_remark' from xml files, and then write to one xml file
		# this function is a preparation for adding remarks in POT templates.
		foldermy=FolderMy()
		filelist=foldermy.getFileList1(folder_in, 'xml')
		if filelist == False:
			return False
			
		root_out=Element('root', format='XML-POT-REMARK' )
		
		for file_in in filelist:
			elem_table=self._getElement(file_in)
			if len(elem_table) != 0:	# don't append if no items.
				root_out.append(elem_table)
		
		# write out
		elem_my=ElementMy()
		if (elem_my.write(file_out, root_out)):
			return True
		else:
			return False	
	
	def _getElement(self, file_in):
		# for getFile_POT_Remark
		
		_list_text=[]
		_list_id_column=[]	# 'id-101:name. id-102:description. id-103, help
		_list_pot_remark=[]
		
		print("\tProcessing file: ", file_in)
		elem_my=ElementMy()
		root_in = elem_my.getroot(file_in)
		v_table=root_in.get('table')
		if v_table == None:
			print("Table name is not available in file %s. Please check and try again." % file_in)
			return
			
		for elem_id in root_in:
			v_id=elem_id.get('id')
			for elem_item in elem_id:
				v_column=elem_item.get('column')
				v_text=elem_item.text
				v_id_column='id-' + v_id + ':' + v_column 
				v_pot_remark=elem_item.get('pot_remark')			
				if v_pot_remark == None :
					v_pot_remark=''
				
				if v_text in _list_text:
					pos=_list_text.index(v_text)
					_list_id_column[pos] += ',' + v_id_column
				else:
					_list_text.append(v_text)
					_list_id_column.append(v_id_column)
					_list_pot_remark.append(v_pot_remark)
					
		elem_table=Element('table', name=v_table)
		for i in range(len(_list_text)):
			elem_item=Element('item', id_column=_list_id_column[i]+'.', pot_remark=_list_pot_remark[i] )
			elem_item.text=_list_text[i]
			elem_table.append(elem_item)
		
		print('\tItems found:', len(elem_table))
		return elem_table
	
	def readFile_POT_Remark( self, file_in = 'pot_remark.xml' ):
		
		# print('\tReading from pot_remark.xml')
		self._list_table =[]	# [ 'AD_Column', 'C_UOM' ]
		self._list_text=[]		# [ [text of 'AD_Column' ], [text of 'C_UOM'] ]
		self._list_pot_remark=[]	# [ [pot remark of 'AD_Column' ], [pot remark of 'C_UOM'] ]
		self._list_id_column=[]		# [ [id_column of 'AD_Column' ], [id_column of 'C_UOM'] ]
		elem_my=ElementMy()
		root_in = elem_my.getroot(file_in)
		
		for elem_table in root_in:
			v_table= elem_table.get('name')
			self._list_table.append(v_table)
			list_text_tmp=[]
			list_pot_remark_tmp = []
			list_id_column_tmp=[]
			for elem_item in elem_table:
				list_text_tmp.append(elem_item.text)
				list_pot_remark_tmp.append( elem_item.get('pot_remark') )
				list_id_column_tmp.append(elem_item.get('id_column'))
					
			self._list_text.append(list_text_tmp)
			self._list_pot_remark.append(list_pot_remark_tmp)
			self._list_id_column.append(list_id_column_tmp)
		# print('\tFinished reading from pot_remark.xml')
	
	def get_POT_Remark( self, v_table, v_text):
		# return POT Remark from xml file
		# file_xml='pot-remark.xml'

		if v_table in self._list_table:
			pos_table = self._list_table.index(v_table)
			
			if v_text in self._list_text[pos_table]:
				pos_text= self._list_text[pos_table].index(v_text)
				v_id_column = self._list_id_column[pos_table][pos_text]
				v_pot_remark = self._list_pot_remark[pos_table][pos_text]
				return v_id_column, v_pot_remark
			else:
				return '',''
		else:
			return '',''
		
class FolderMy:
	
	"Folder"

	def isOverWrite(self, foldername):	
		# This function is to check file operation.
		# Skip, Skip All, Overwrite, Overwrite All

		is_write_folder=False
		request=''
		if os.path.isdir(foldername) :  # check whether the file is existing.
			print("Folder \"%s\" already existed. Do you want to overwrite it? " % foldername)
			print("S: Skip / W: Overwrite")
			while True:
				request=input ("Please choose (type UPPER character): ")
				request=request.strip()
				if request == 'S':
					print("Folder is kept.")
					is_write_folder=False
					break
				elif request == 'W':
					print("Folder will be deleted & re-created.")
					is_write_folder=True
					break
				else :
					print("Wrong inputs. Please type: S or W. Try agian.")
		else  : # file does not exist
			is_write_folder=True
			
		return is_write_folder

	def isExist(self, folder, type):
		if (not os.path.exists(folder)):	# Not exist
			if ( type=='read' ):
				print("\tError! Folder %s doesn't exist." % folder)
				return False
			elif ( type=='write'):	
				os.mkdir(folder)	# create folder
				print("\tFolder %s is created." % folder)
				return True
			else:
				print("\tError! Unknow type in FolderMy.isExist")
				return False
		else:
			
			if ( type=='write'):
				print("Folder already exists. Files will be overwritten: " , folder)
				'''
				if self.isOverWrite(folder):
					shutil.rmtree(folder)
					os.mkdir(folder)
					
				'''
			return True
		
	def getMatchFileList(self, folder1, folder2, stype):
		# get matched file. e.g. "AD_Column_Trl_en_US.xml" with "AD_Column_Trl_zh_CN.xml"
		# this function is for:  python3.1 tool4po.py --check-folder 'en_US_4po' 'zh_CN_4po' 'check' True
		# getMatchFileList(self, 'en_US_4po' 'zh_CN_4po')
		if (stype=='xml'):
			str_pattern1='xml'
			str_pattern2='xml'
		elif ( stype=='po'):
			str_pattern1='po'
			str_pattern2='po'
		elif ( stype=='xml-po'):
			str_pattern1='xml'
			str_pattern2='po'
		else:
			print('\tError! Wrong type in getMatchFileList')
			return False
			
		filelist1=self.getFileList1(folder1, str_pattern1)
		filelist2=self.getFileList1(folder2, str_pattern2)
				
		filelist_match=[]	# for return
		
		# get file name. e.g. "AD_Column_Trl_en_US.xml"
		filelist2_name=[]
		for f2 in filelist2:
			f2_name=os.path.split(f2)[1]
			filelist2_name.append(f2_name)

		for f1 in filelist1 :
			f1_name=os.path.split(f1)[1]		# get file name. e.g. "AD_Column_Trl_en_US.xml"
			re_trl=re.search('_[tT][rR][lL]_', f1_name)
			if ( re_trl !=  None):
				v_head_pos=re_trl.span()[0]		# get first pos of '_Trl_'
				f1_name_head_lower=f1_name[:v_head_pos].lower()	# get head. e.g."AD_Column"
				
				# search correspondent file in folder2
				pos=-1
				for f2_name in filelist2_name:
					pos +=1
					# # get matching file name. e.g. "AD_Column_Trl_zh_CN.xml"
					re_trl=re.search(f1_name_head_lower + '_[tT][rR][lL]', f2_name.lower())
					if ( re_trl !=  None):
						filelist_match.append([f1, filelist2[pos]])
						break
		
		filelist_match.sort()
		return filelist_match
	
	def getFileList1(self, folder, filetype):
		# get file list 
		if( not self.isExist(folder, 'read')):
			return False
		
		if ( filetype == 'xml'):
			s_pattern='\.[xX][mM][lL]$'
		elif ( filetype == 'po-pot'):
			s_pattern= p2='\.[pP][oO]$|\.[pP][oO][tT]$'
		elif ( filetype == 'po'):
			s_pattern= p2='\.[pP][oO]$'
		elif ( filetype == 'pot'):
			s_pattern= p2='\.[pP][oO][tT]$'
		else:
			print('\tERROR! Wrong filetype in getFileList1')
			return False
			
		filelist=[]
		for  parent, dirnames, filenames  in  os.walk(folder):
			for  filename  in  filenames:
				if ( re.search(s_pattern, filename) != None ):
					filelist.append(os.path.join(parent, filename))
					

		filelist.sort()
		return filelist
		
	def getFileList2(self, folder_in, folder_out, type, lan_origin='', lan_replace=''):
		# mark: reviewed
		# get file list
		# [ [ source filename, target filename ], ... ]
		# e.g. [ ['en_US/AD_Column_Trl_en_US.xml', 'en_US_4po/AD_Column_Trl_en_US.xml'], ... ]
		if (not self.isExist(folder_in, 'read')):
			return False
		if (not self.isExist(folder_out, 'write')):
			return False
		
		# default setting
		list_sub=[]  # it is for file head. e.g. AD_Column_Trl_en_US.xml
		is_folder_only=False
		
		if ( type == 'xml'):
			s_pattern='*.[xX][mM][lL]'
			f2_name_suffix='.xml'
			is_repeat_suffix=False
		elif (type == 'xml-lan'):	# this is for language reset
			s_pattern='*.[xX][mM][lL]'
			list_sub=[[lan_origin, lan_replace]]
			f2_name_suffix='.xml'
			is_repeat_suffix=False
		elif ( type=='xml2pot'):
			s_pattern='*.[xX][mM][lL]'
			list_sub=[[ '_[tT][rR][lL]_.*$', '_Trl']]
			f2_name_suffix='.pot'
			is_repeat_suffix=False
		elif ( type=='pot2pot'):
			s_pattern='*.[pP][oO][tT]'
			list_sub=[[ '_[tT][rR][lL]_.*$', '_Trl']]
			f2_name_suffix='.pot'
			is_repeat_suffix=False
		elif ( type=='pot2po'):
			s_pattern='*.[pP][oO][tT]'
			f2_name_suffix='.po'
			is_repeat_suffix=False
		elif ( type=='lp-pkg-pot'):	# for lp-package
			s_pattern='*.[pP][oO][tT]'
			f2_name_suffix=''
			is_repeat_suffix=True
		elif ( type=='lp-pkg-po'):	# for lp-package
			s_pattern='*.[pP][oO]'
			f2_name_suffix=''
			is_repeat_suffix=True
		else :
			print ( '\tError! Wrong type in getFileList2!')
			return False
			
		filelist=[]		
		try:
			#(dirname, filename) = os.path.split(pathname) 
			str_search= os.path.join(folder_in, s_pattern)
			for f1 in glob.glob(str_search) :
				f1_name=os.path.split(f1)[1]		# get file name 
				(f1_name_1, f1_name_2)=os.path.splitext(f1_name)	# split file name
				if ( len(list_sub)==0 ):
					f2_name_head=f1_name_1
				else:
					for [sub1, sub2] in list_sub:
						f2_name_head=re.sub(sub1, sub2, f1_name_1)
				if is_repeat_suffix:
					f2_name=f2_name_head +f1_name_2
				else:
					f2_name=f2_name_head +f2_name_suffix
				f2=os.path.join(folder_out, f2_name)
				if is_folder_only:
					if os.path.isdir(f1):
						filelist.append([f1, f2])
				else:
					filelist.append([f1, f2])
		except Exception as inst: # Check whether the file_in is existing
			print( "Unexpected error while listing files from folder %s: %s" % (folder_in, inst))
			return
			
		if ( type=='lp-pkg-pot'):	# for lp-package pot
			for i in range(len(filelist)):
				f1 = filelist[i][0]
				f1_name=os.path.split(f1)[1]
				f1_name_head=os.path.splitext(f1_name)[0]
				f2=os.path.join(folder_out, f1_name_head, f1_name)
				filelist[i][1]=f2
		elif ( type=='lp-pkg-po'):	# for lp-package po
			sysmy=SystemMy()
			str_shortname = sysmy.getShortnameDefault()
			for i in range(len(filelist)):
				f1 = filelist[i][0]
				f1_name=os.path.split(f1)[1]
				f1_name_head=os.path.splitext(f1_name)[0]
				f2_name= str_shortname + '.po'
				f2=os.path.join(folder_out, f1_name_head, f2_name)
				print((folder_out, f1_name_head, f2_name))
				filelist[i][1]=f2
		filelist.sort()
		return filelist
		
class FileXMLList():
	
	def write(self, file_list_tra, file_out_1, file_out_2):
		# .write('list_trans.xml', 'list_tmp_en_US.xml', 'list_tmp_zh_CN.xml')
		print("-------------------------------------------------")
		print("\tlist_trans.xml --> list_tmp_en_US.xml & list_tmp_[LANGUAGE_DEFAULT].xml")
		print("-------------------------------------------------")
		elem_my=ElementMy()
		elem_my.readItemList1(file_list_tra, 'XML-LST-MIX')
		listOrigin=elem_my.getListOrigin()
		listTrans=elem_my.getListTrans()
		
		len_ori=len(listOrigin)
		len_tra=len(listTrans)
		if len_ori != len_tra:
			print('\tError! len(ori) != len(tra).', len_ori , len_tra)
			return False
		
		root_ori=Element('root', format='XML-LST-SNG', count=str(len_ori), language='en_US')
		root_tra=Element('root', format='XML-LST-SNG', count=str(len_ori), language=LANGUAGE_DEFAULT)
		
		for i in range(len_ori):
			text_ori = listOrigin[i]	
			text_tra = listTrans[i][0]	# attention to listTrans structure
			
			if (( text_ori != '') and (text_tra != '')):
				
				elem_ori=Element('item', original=text_ori)
				elem_ori.text=text_ori
				root_ori.append(elem_ori)
				
				elem_tra=Element('item', original = text_ori)
				elem_tra.text = listTrans[i][0]
				root_tra.append(elem_tra)
				
		elem_my.write(file_out_1, root_ori)
		elem_my.write(file_out_2, root_tra)
		return True
					
class SystemMy():
	def __init__(self):
		self._listLanguageInfo=[]
		self.read('system.xml', 'config.xml')
		
	def getLanguageDefault(self):
		return self._languageDefault
	
	def getMethodDefault(self):		
		return self.getLanguageInfo(self._languageDefault, 'method')
	
	def getPatternDefault(self):
		return self.getLanguageInfo(self._languageDefault, 'pattern')
		
	def getShortnameDefault(self):
		return self.getLanguageInfo(self._languageDefault, 'shortname')
	
	def getLangCountryName(self, shortname):
		for [str_language, str_method, str_pattern, str_shortname] in self._listLanguageInfo:
			if shortname==str_shortname:
				return str_language
		print(' Error: Pattern of language %s is NOT found! ' % shortname )
		return None
	
	def getLanguageInfo(self, language, stype):
		for [str_language, str_method, str_pattern, str_shortname] in self._listLanguageInfo:
			if ( language == str_language ):
				if ( stype == 'method' ):
					return str_method
				elif ( stype == 'pattern'):
					return str_pattern
				elif ( stype == 'shortname'):
					return str_shortname
				else:
					print('\tError! Wrong type in SystemMy.getLanguageInfo: ', stype)
					return False
		print(' Error: Pattern of language %s is NOT found! ' % language )
		return False
	
	def getHeadPo(self):
		return self.headPo
	
	def getHeadPot(self):
		return self.headPot
		
	def getAdempiereVersion(self):
		return self.adempiereVersion
		
	def getVersion(self):
		return self.version
		
	def getHelp(self):
		return self.help
	
	def read(self, file_sys, file_con):
		# read('system.xml', 'config.xml')
		elem_my=ElementMy()
		
		# Part 1. Config.xml
		root_con=elem_my.getroot(file_con)
		item=root_con.find('default-language')
		self._languageDefault=item.text
		
		elem=root_con.getiterator('language')
		for item in elem:
			str_language=item.text.strip()
			str_method=item.get('method')
			str_pattern=item.get('pattern')
			str_shortname=item.get('shortname')
			self._listLanguageInfo.append([str_language, str_method, str_pattern, str_shortname])
					
		item=root_con.find('head-po')
		self.headPo=item.text
		
		item=root_con.find('head-pot')
		self.headPot=item.text
		
		item=root_con.find('adempiere-version')
		self.adempiereVersion=item.text
		
		# Part 2. System.xml
		root_sys=elem_my.getroot(file_sys)
		
		item=root_sys.find('version')
		self.version=item.text
		
		item=root_sys.find('help')
		self.help=item.text
		
class ListMy:
	' item list'
	' Designed for def run_get_list_trans(folder_ori, folder_tra, file_out)'
	
	def __init__(self):
		self.listOrigin=[]	# ['name', ... ]
		self.listTrans=[]	# [['name1', 'name2'], ... ]
		self.listSelect=[]	# [ pos1, pos2 , ... ]
		self.listSourceMark=[]  # [['mark1', 'mark2'], ...]
		self.setOnlyTrans(True)
		self._isAddSourceMark=False

	def setOnlyTrans(self, booleanVal):
		self.isOnlyTrans=booleanVal

		
	def _set_sourcemark(self, str_sourcemark):
		# set source mark
		# especially designed for : combine different version of translations.
		# source mark will appear in list_trans_ll_LL.xml file
		if str_sourcemark!="":
			self._sourcemark=str_sourcemark
			self._isAddSourceMark=True
		else:
			self._sourcemark=""
			self._isAddSourceMark=False
				
	def addList(self, list_ori, list_tra, list_tra_original=[], str_sourcemark=""):
		# list_tra=[ ['origin', 'trans'], [], ... ]
		# list_tra_original is designed for western languages like German.
		if (not isinstance(list_ori, list)) :
			print('\tWarning, it is not a list. list_ori')
			return False
			
		if (not isinstance(list_tra, list)) :
			print('\tWarning, it is not a list. list_tra')
			return False
			
		if (not isinstance(list_tra_original, list)) :
			print('\tWarning, it is not a list. list_tra_original')
			return False
		
		self._set_sourcemark(str_sourcemark)
			
		ilen_ori=len(list_ori)
		if len(list_tra_original) == 0:	# for None German like languages
			for i in range(ilen_ori):
				str_ori=list_ori[i]
				for str_tra in list_tra[i]:
					self._addItem(str_ori, str_tra)
		elif len(list_tra_original) == ilen_ori:  # for German like languages
			for i in range(ilen_ori):
				str_ori=list_ori[i]
				str_tra_original=list_tra_original[i]
				for str_tra in list_tra[i]:
					self._addItem(str_ori, str_tra, str_tra_original)
		else:
			print('\tWarning! len(list_tra_original) != len(list_ori)')
			return False
				
		return True
		
	def _addItem(self, s_text_ori, s_text_tra, s_text_tra_original=None):
		
		# add item
		# s_text_tra_original is designed for western languages like German.
		mytext=TextMy()
		if self.isOnlyTrans:	# only accept translation
			if not mytext.isTranslation(s_text_ori, s_text_tra,  s_text_tra_original):
				return False
			
		# Remove duplicate '\n':
		#   AD_Window_Trl.po:2977: `msgid' and `msgstr' entries do not both end with '\n'
		#   msgfmt: found 1 fatal errors
		if (s_text_ori[-1] != '\n') and (s_text_tra[-1] == '\n'):
			s_text_tra=s_text_tra.rstrip('\n')
		
		'''	
		# temporary function
		# [condition, replace from, replace to]
		list_replace=[['line','明细', '行'], ['detail','详情', '明细'] ,['detail','详细', '明细'] ,['detail','细节', '明细']  ]
		
		for [rep_con, rep_fr, rep_to] in list_replace:
			if rep_con in s_text_ori.lower():
				 s_text_tra=s_text_tra.replace(rep_fr, rep_to)
		
		# end of temporary function
		'''
			
		if ( s_text_ori in self.listOrigin): # multi origin text
			p_ori=self.listOrigin.index(s_text_ori)
			if ( s_text_tra not in  self.listTrans[p_ori] ):
				# add new translation
				self.listTrans[p_ori].append(s_text_tra)
				self.listSourceMark[p_ori].append(self._sourcemark)
			elif (self._isAddSourceMark):
				# add source mark
				p_trans=self.listTrans[p_ori].index(s_text_tra)
				if self._sourcemark not in self.listSourceMark[p_ori][p_trans]:
					# Don't add source mark duplicated.
					self.listSourceMark[p_ori][p_trans]+=self._sourcemark
		else:	# new origin
			self.listOrigin.append(s_text_ori)
			self.listTrans.append([s_text_tra])
			self.listSourceMark.append([self._sourcemark])
		
	def reorganize(self):
		# re-organize: sort, select
		self._sort()
		self._select()
	
	def _sort(self):
		ilen=len(self.listOrigin)
		list_temp=[]
		for i in range(ilen):
			list_mini=[self.listOrigin[i], self.listTrans[i], self.listSourceMark[i]]
			list_temp.append(list_mini)
		
		list_temp.sort()
		self.listOrigin=[]
		self.listTrans=[]
		self.listSourceMark=[]
		
		for i in range(ilen):
			self.listOrigin.append(list_temp[i][0])
			self.listTrans.append(list_temp[i][1])
			self.listSourceMark.append(list_temp[i][2])
			
	def _select(self):
		self.listSelect=[]
		ilen=len(self.listOrigin)
		list_temp=[]
		textmy=TextMy()
		for i in range(ilen):
			list_score=[]
			
			if len(self.listTrans[i]) == 1:
				self.listSelect.append(0) 
			else:
				jlen=len(self.listTrans[i])
				for j in range(jlen):
					score1=textmy.transScore(self.listTrans[i][j])
					# for score2 , please set with you source mark
					if self.listSourceMark[i][j] == 'cm330':
						score2=1.6
					elif self.listSourceMark[i][j] == 'ad330cm330':
						score2=1.3
					else:
						score2=1
					list_score.append(score1*score2)
				max_score=max(list_score)
				# append the pos of max score
				self.listSelect.append(list_score.index(max_score)) 
					
	def write(self, filename):
		
		# write to file
		# ATTENTION: Please run listmy.reorganize() first !
		
		elem_single=Element('single')
		elem_multi=Element('multi')
		len_ori=len(self.listOrigin)
		for i in range(len_ori):
			elem_item=Element('item')
			elem_item.set('original', self.listOrigin[i])
			i_select=self.listSelect[i]
			elem_item.text=self.listTrans[i][i_select]
			elem_item.set('source', self.listSourceMark[i][i_select])
			
			len_tra=len(self.listTrans[i])
			if len_tra==1:
				elem_single.append(elem_item)
			else:
				elem_case=Element('case')
				elem_case.append(elem_item)
				len_tra=len(self.listTrans[i])
				for j in range(len_tra):
					if j != i_select:	# ignore the selected text
						elem_ref=Element('reference')
						elem_ref.text=self.listTrans[i][j]
						elem_ref.set('source', self.listSourceMark[i][j])
						elem_case.append(elem_ref)
				elem_multi.append(elem_case)
				
		root=Element('root', format='XML-LST-MIX', language=LANGUAGE_DEFAULT, count=str(len_ori))
		root.append(elem_single)
		root.append(elem_multi)
		
		elem_my=ElementMy()
		elem_my.write(filename, root)
		
class ListMsg():
	# list of Msgid / msgstr / sharp
	def __init__(self):
		self.list_msgid_natural=[]
		self.list_msgid_slim=[]
		self.list_msgstr=[]
		self.list_sharp=[]		
				
	def _tidyMsg(self, ls_text, stype):
		# get msgid / msgstr from ls_text
		# ls_text:  list. [ '   ', '   ', ... ]
		# type : slim
		# type : natural
		stext=''
		if ( stype=='slim'):
			for stext1 in ls_text:
				# attention to 'space'
				stext2=re.sub('^ *\"', '', stext1)
				# deal with top line. such as  msgid ""
				stext2=re.sub('^ *msgid *\"', '', stext2)
				stext2=re.sub('^ *msgstr *\"', '', stext2)	
				stext2=re.sub('\" *\n*$', '', stext2)
				stext += stext2
		elif ( stype=='natural'):
			for stext1 in ls_text:
				stext += stext1
		else:
			print('\tError! Wrong type in TextMy.getMsg()')
			return False
		return stext

		
	def _addItem(self, str_msgid, str_msgstr, str_sharp, isRemoveEmptyMsg=True):
		# add itmem into self.list_msgid, self.list_msgstr
		str_msgid_natural = self._tidyMsg(str_msgid, 'natural' )
		str_msgid_slim =self._tidyMsg(str_msgid, 'slim' )
		str_msgstr=self._tidyMsg(str_msgstr, self._type_msgstr )
		str_sharp=self._tidyMsg(str_sharp,  'natural' )
		
		if  (( str_msgid_slim == False ) or (str_msgstr == False)):
			return False
		elif  (( str_msgid_slim == None ) or (str_msgstr == None)):
			return False
		elif ( str_msgid_slim == '' ):
			# ignore the top msgid
			return False
		elif ( re.search('^ *msgid \"\" *\n*$', str_msgid_slim) !=  None ):
			# ignore the top msgid
			return False
			
		if (isRemoveEmptyMsg and (str_msgstr.strip()=='') ):
			isAdd=False
		elif (isRemoveEmptyMsg and (str_msgstr.strip()=='msgstr \"\"') ):
			isAdd=False
		elif (str_msgid_slim in self.list_msgid_slim): # remove duplicate items
			isAdd=False
		else:
			isAdd=True
						
		if isAdd:
			self.list_msgid_slim.append(str_msgid_slim)
			self.list_msgid_natural.append(str_msgid_natural)
			self.list_msgstr.append(str_msgstr)
			self.list_sharp.append(str_sharp)
		return True
	
	def _setType(self, type_msgstr):
		self._type_msgstr = type_msgstr
		return
		
	def readList_Msg(self, file_in, itype=1, isRemoveEmptyMsg=True):
		# read list_msg from po file
		
		# Part 1. itype
		# itype = 1 
		# itype = 2
		# _setType(type_msgid, type_msgstr, type_sharp)
		if ( itype==1):
			self._setType('natural')
		elif ( itype==2):
			self._setType('slim')
		else:
			print('\tError! Wrong type in readList_Msg')
			return False
		
		# Part 2. Initial
		try:
			fl_in=open(file_in, encoding='utf-8')
		except Exception as inst: # Check whether the file is existing
			print("Unexpected error opening %s: %s" % (file_in, inst))
			return False
			
		ls_text=[]	# list
		str_type_last=''
		str_type_cur=''
	
		s_pattern_msgid='^ *msgid'
		s_pattern_msgstr='^ *msgstr'
		s_pattern_sharp='^#'
		
		ls_sharp=[]
		mytext=TextMy()
		is_new_start=False
		
		# Part 3. Go through all po file
		for ln_in in fl_in:	
			if (re.search(s_pattern_msgid, ln_in) !=  None): # msgid
				str_type_last=str_type_cur
				str_type_cur='msgid'
				is_new_start=True
			elif (re.search(s_pattern_msgstr, ln_in) !=  None):	# msgstr
				str_type_last=str_type_cur
				str_type_cur='msgstr'
				is_new_start=True
			elif (re.search(s_pattern_sharp, ln_in) !=  None):	# sharp
				ls_sharp.append(ln_in)
				
			if ( (ln_in.strip() == '')):	# strip() remove space & '\n'  & '\t'
				str_type_last=str_type_cur
				str_type_cur=''
				is_new_start=True
			
			if ( is_new_start ):
				if (str_type_last=='msgid'): # No need this judgement
					str_msgid=ls_text
				elif (str_type_last=='msgstr'):
					str_msgstr=ls_text
					str_sharp=ls_sharp
					
					self._addItem(str_msgid, str_msgstr, str_sharp, isRemoveEmptyMsg)
					ls_sharp=[]
				# restore settings
				is_new_start=False
				ls_text=[] # re-fresh ls_text
				
			ls_text.append(ln_in)
		# end of:  for ln_in in fl_in
		
		# for the last line
		if (str_type_cur=='msgstr'):
			str_msgstr=ls_text
			str_sharp=ls_sharp
			self._addItem(str_msgid, str_msgstr, str_sharp, isRemoveEmptyMsg)
		fl_in.close()
		
	def write(self, filename):
		# write po file

		try:
			filemy=FileMy()
			if filemy.isOverWrite(filename):
				pass
			else:
				return True
				
			ilen=len(self.list_msgid_natural)
			list_sort=[]
			for i in range(ilen):
				list_sort.append([self.list_msgid_natural[i], self.list_msgstr[i], self.list_sharp[i]])
			list_sort.sort()
				
			
			fl_out=open(filename, mode='w', encoding='utf-8')
			
			sysmy=SystemMy()
			fl_out.write(sysmy.getHeadPo())
			fl_out.write('\n\n')
			
			for i in range(ilen):
				'''
				fl_out.write(self.list_sharp[i])
				fl_out.write(self.list_msgid_natural[i])
				fl_out.write(self.list_msgstr[i])					
				'''
				fl_out.write(list_sort[i][2])	# sharp
				fl_out.write(list_sort[i][0])	# msgid
				fl_out.write(list_sort[i][1])	# msgstr
				fl_out.write('\n')
			fl_out.close()
			
		except Exception as inst: # Check whether the file_in is existing
			print( "Unexpected error writing %s: %s" % (filename, inst))
			return False
			
		return True
			
		
	def getList_Msg(self, type_msgid):
		# return self.list_msgid, self.list_msgstr, self.list_sharp
		# Part 1.
		len_msgid=len(self.list_msgid_slim)
		len_msgstr=len(self.list_msgstr)
		if ( len_msgid==0):
			print( '\tWarning! No msgid found')
			return False
		elif( len_msgid != len_msgstr):
			print('\tError! len_msgid != len_msgstr')
			return False
		else:
			print('\t    Msgid - Msgstr found: ',len_msgid)
			if type_msgid == 'slim':
				return self.list_msgid_slim, self.list_msgstr, self.list_sharp
			elif type_msgid == 'natural':
				return self.list_msgid_natural, self.list_msgstr, self.list_sharp
			else:
				print( '\tError! Wrong type in ListMsg.getList_Msg().')
				return False
			
		
	def getStrMatch(self, str_msgid, stype='slim'):
		# get related msgstr / sharp from msgid
		if (stype == 'slim'):
			pass
		elif (stype == 'natural'):
			# convert to slim
			str_msgid = self._tidyMsg(str_msgid.split('\n'), 'slim')
		else:
			print('\tWarning! Wrong type in getStrMatch!', stype)
			return False
			
		if ( str_msgid  in self.list_msgid_slim):
			i_pos=self.list_msgid_slim.index(str_msgid)
			str_msgstr=self.list_msgstr[i_pos]
		else:
			str_msgstr='msgstr \"\"\n'
		return str_msgstr
		
class ElementMy:
	'Element Tree'
	def __init__(self):
		self.listOrigin=[]
		self.listTrans=[]
		# self.listTrans_Original is specially designed for western languages like German.
		# Original in trans: e.g. <value column="Name" original="Table and Column">Table and Column</value>
		self.listTrans_Original=[]
	
	def getroot(self, filename):
		try:
			tree_in = ElementTree()		# XML tree input
			tree_in.parse(filename)	# read XML file
			root_in = tree_in.getroot() # <root>
			return root_in
		except Exception as inst: # Check whether the file is existing
			print("Unexpected error opening %s: %s" % (filename, inst))
			return False
	
	def _indent(self, elem, level=0):
		# indent in ElementTree. pretty print format
	    i = "\n" + level*" "	# changed to 1 space on Aug 08, 2010
	    if len(elem):
	        if not elem.text or not elem.text.strip():
	            elem.text = i + " "
	        if not elem.tail or not elem.tail.strip():
	            elem.tail = i
	        for elem in elem:
	            self._indent(elem, level+1)
	        if not elem.tail or not elem.tail.strip():
	            elem.tail = i
	    else:
	        if level and (not elem.tail or not elem.tail.strip()):
	            elem.tail = i

	def write(self, filename, elem_root):
		# elem_root: Element
		try:
			tree_out=ElementTree()
			filemy=FileMy()
			if filemy.isOverWrite(filename):
				self._indent(elem_root)	# indent
				tree_out._setroot(elem_root)
				tree_out.write(filename, encoding="utf-8")	
		except Exception as inst: # Check whether the file_in is existing
			print( "Unexpected error writing %s: %s" % (filename, inst))
			return False
			
		return True	
	
	def _addItem(self, str_ori, str_tra, str_tra_original = None):
		# add item to self.listTrans & self.listOrigin
		# Attention to None or ''
		if (( str_ori == None ) or (str_tra == None)):
			return False
		if (( str_ori == '' ) or (str_tra == '' )):
			return False
		if 	( str_ori in self.listOrigin ):
			pos=self.listOrigin.index(str_ori)
			if ( str_tra not in self.listTrans[pos]):
				self.listTrans[pos].append(str_tra)
		else:
			self.listOrigin.append(str_ori)
			self.listTrans.append([str_tra])
			self.listTrans_Original.append(str_tra_original)		
		return True
	
	def getListOrigin(self):
		return self.listOrigin
		
	def getListTrans(self):
		return self.listTrans
		
	def getListTrans_Original(self):
		# self.listTrans_Original is specially designed for western languages like German.
		return self.listTrans_Original
									
	def readItemList1(self, file_in, file_type):
		# Attention: get exact original text, don't strip
		root=self.getroot(file_in)
		print('\tProcessing :' ,file_in)
		
		if ( file_type=='XML-AD' ):
			ls_el=root.getiterator('value')
			for elem1 in ls_el:
				s_text_ori= elem1.get('original')
				s_text_tra= elem1.text
				self._addItem(s_text_ori, s_text_tra)
		elif ( file_type=='XML-LST-MIX' ): # Only read for single & selected
			ls_el=root.getiterator('item')
			for elem1 in ls_el:
				s_text_ori= elem1.get('original')
				s_text_tra= elem1.text
				self._addItem(s_text_ori, s_text_tra)
		elif ( file_type=='XML-LST-MIX-ALL' ): # read for all
			elem_single=root.find('single')
			print('find single')
			for child1 in elem_single:
				s_text_ori= child1.get('original')
				s_text_tra= child1.text
				self._addItem(s_text_ori, s_text_tra)
				
			elem_multi=root.find('multi')
			print('find multi')
			for child1 in elem_multi:	# <case>
				for child2 in child1:
					if (child2.tag == 'item'):
						s_text_ori= child2.get('original')
						s_text_tra= child2.text
						self._addItem(s_text_ori, s_text_tra)
					elif ( child2.tag == 'reference'):
						s_text_tra= child2.text
						self._addItem(s_text_ori, s_text_tra)
					else:
						print('\tERROR! wrong tag!\n')
						
						
		else:
			print('\tWarning! Wrong file_type in ElementMy.readItemList1: ', file_type)			
		
		# Part X. Finial
		if (len(self.listTrans)==0):
			print('\tWarning: No translation found in this file.')
			return False
		else:
			return self.listTrans
			
	def readItemList2(self, file_ori, file_tra):
		# Read item list.
		# Change to file format: XML-AD. Abanden XML-4PO. Aug 08, 2010. Peanut Blake
		# Attention: 
		# 	Base on format: XML-AD
		#   multi-item like <Name> <PrintName>...
		#   null like <PO_Name />
		'''
<adempiereTrl language="en_US" table="AD_Window">
 <row id="100" trl="Y">
  <value column="Name" original="Table and Column">Table and Column</value>
  <value column="Description" original="Maintain Tables and Columns">Maintain Tables and Columns</value>
  <value column="Help" original="The Table and Column Window defines all tables with their columns">The Table and Column Window defines all tables with their columns</value>
 </row>
</adempiereTrl>
		'''

		# Part 1. Initialize
		elem_my=ElementMy()
		textmy=TextMy()
		root_ori = elem_my.getroot(file_ori)
		root_tra = elem_my.getroot(file_tra)
		if ( ( root_ori == False )  or (root_tra == False) ):
			return False
		print('\tProcessing :' ,root_ori.get('table'))
		
		# Part 2: go through for origin  --> dict_ori
		dict_ori={}  # define dictionary
		for child_row in root_ori:
			tmp_id=child_row.get('id')
			if (tmp_id != None) and (tmp_id != ''):
				tmp_dict={}
				for child_value in child_row:
					tmp_column=child_value.get('column')
					tmp_text=child_value.text
					if tmp_column != None :
						tmp_dict.update({tmp_column:tmp_text})
				dict_ori.update({tmp_id:tmp_dict})
				
		# Part 3: go through for translation.
		for child_row in root_tra:
			tmp_id=child_row.get('id')
			if (tmp_id != None) and (tmp_id != ''):
				# look for the same id
				dict_ori_id=dict_ori.get(tmp_id)
				if dict_ori_id != None:
					for child_value in child_row:
						tmp_column=child_value.get('column')
						tmp_tra_original=child_value.get('original')
						tmp_tra=child_value.text
						if tmp_column != None :
							# look for the same column
							tmp_ori=dict_ori_id.get(tmp_column)
							if tmp_ori != None:
								# ok, add item
								self._addItem(tmp_ori, tmp_tra, tmp_tra_original )
		# end of ==for child_row in root_tra==


class ToolPO():
	# po4a - update both the po files and translated documents in one shot
		
	def msgfmt(self, folder):
		# Batch checking PO / POT files with 'msgfmt -cv'
		# This function requires msgfmt pre-installed.
		print("-------------------------------------------------")
		print("\tBatch check files with msgfmt" )
		print("-------------------------------------------------")
		foldermy=FolderMy()
		ls_file=foldermy.getFileList1(folder, 'po-pot')
		
		if (ls_file == False):
			print("No *.PO / *.POT file is found in folder. Please check and try again." )
			return False
		
		# step 3: batch msgfmt
		mytext=TextMy()
		for fn in ls_file :
			print("  Processing file: ", mytext.getFileNameHead(fn, 'trl'))
			sys1='msgfmt -cv \"' + fn + '\"'
			os.system(sys1)
			print("\n")
		print("\tFinished!" )
		print("\tTotal file processed :", len(ls_file))
		print("-------------------------------------------------")
		
	def getPO_Trans(self, file_xml_ori, file_xml_tra, file_po_output):
		print("-------------------------------------------------")
		print("\tGet list_trans.po from list_trans.xml" )
		print("-------------------------------------------------")
		print("\tProcessing: ", file_xml_ori)
		# po4a-gettextize -f xml -M 'UTF-8' -m list_origin_3.xml -L 'UTF-8' -l list_trans_3.xml -p list_trans.po
		
		sys_head="po4a-gettextize -f xml "
		sys_ori=" -M \'UTF-8\' -m \'" + file_xml_ori + "\'"
		sys_tra=" -L \'UTF-8\' -l \'" + file_xml_tra + "\'"
		sys_out=" -p \'" + file_po_output + "\'"
		sys_sum=sys_head + sys_ori + sys_tra + sys_out
		# recover
		print('\tCommand:\n')
		print(sys_sum)
		os.system(sys_sum)
		print("\tFinished!" )
		print("-------------------------------------------------")
			
	def getPOT(folder_xml_input, folder_pot_output):
		# "Step 1: \tBatch gettextize files by po4a-gettextize"
		foldermy=FolderMy()
		filelist=foldermy.getFileList2(folder_xml_input, folder_pot_output, 'xml2pot')
		
		if filelist == False:
			print('\tError! Please check and try again!')
			return True
			
		mytext=TextMy()
		print("-------------------------------------------------")
		print("\tBatch gettextize files by po4a-gettextize" )
		print("-------------------------------------------------")
		for [file_xml, file_po] in filelist :
			print("  Processing file: ", mytext.getFileNameHead(file_xml, 'trl'))
			# "po4a-gettextize -f xml -m \"ori en.xml\" -p \"out en.pot\""
			sys_head="po4a-gettextize -f xml "
			sys_xml=" -M \'UTF-8\' -m \'" + file_xml + "\'"
			sys_out=" -p \'" + file_po + "\'"
			sys_sum=sys_head + sys_xml + sys_out
			os.system(sys_sum)
		print("\tFinished!" )
		print("\tTotal files processed: " , len(filelist) )
		print("-------------------------------------------------")
	
	def getXML(self, folder_xml_en_input, folder_po_input, folder_xml_trans_output, str_lang=''):
		# "Step 1: \tBatch gettextize files by po4a-gettextize"
		foldermy=FolderMy()
		if str_lang=='' :
			str_lang=LANGUAGE_DEFAULT
		
		filelist1=foldermy.getMatchFileList(folder_xml_en_input, folder_po_input, 'xml-po')		
		filelist2=foldermy.getFileList2(folder_xml_en_input, folder_xml_trans_output, 'xml-lan', 'en_US', str_lang)
		filelist=[]
		for (file_xml_en, file_po ) in filelist1:
			for ( file_xml_en_2, file_xml_trans )  in filelist2:
				if ( file_xml_en == file_xml_en_2):
					filelist.append([file_xml_en, file_po, file_xml_trans ] )
					break
		if filelist == False:
			print('\tError! Please check and try again!')
			return True
		elif len(filelist)==0:
			print('\tWarning! No matching files found. Please check and try again!')
			return True
		
		mytext=TextMy()
		print("-------------------------------------------------")
		print("\tBatch getting translation XML files by po4a-translate" )
		print("-------------------------------------------------")
		for [file_xml_en, file_po, file_xml_trans] in filelist :
			print("  Processing file: ", mytext.getFileNameHead(file_xml_en, 'trl'))
			# $ po4a-translate -f xml -M 'UTF-8' -m orig.xml -p list_trans.po -k 0 > trans.xml
			sys_head="po4a-translate -f xml "
			sys_xml=" -M \'UTF-8\' -m \'" + file_xml_en + "\'"
			sys_po=" -p \'" + file_po + "\'"
			sys_out=" -k 0 > \'" + file_xml_trans + "\'"
			sys_sum=sys_head + sys_xml + sys_po + sys_out
			os.system(sys_sum)
		print("\tFinished!")
		print("\tTotal files processed: " , len(filelist) )
		print("-------------------------------------------------")
		
	
	def getXML_simple(self, folder_xml_en_input, file_po_input, folder_xml_trans_output, str_lang=''):
		# "Step 1: \tBatch gettextize files by po4a-gettextize"
		foldermy=FolderMy()
		if str_lang=='' :
			str_lang=LANGUAGE_DEFAULT
		
		filelist1=foldermy.getFileList1(folder_xml_en_input, 'xml')
		filelist2=foldermy.getFileList2(folder_xml_en_input, folder_xml_trans_output, 'xml-lan', 'en_US', str_lang)
		
		filelist=[]
		for file_xml_en in filelist1:
			for ( file_xml_en_2, file_xml_trans )  in filelist2:
				if ( file_xml_en == file_xml_en_2):
					filelist.append([file_xml_en, file_po_input, file_xml_trans ] )
					break
		if filelist == False:
			print('\tError! Please check and try again!')
			return True
		elif len(filelist)==0:
			print('\tWarning! No matching files found. Please check and try again!')
			return True
		
		mytext=TextMy()
		print("-------------------------------------------------")
		print("\tBatch getting translation XML files by po4a-translate" )
		print("-------------------------------------------------")
		for [file_xml_en, file_po, file_xml_trans] in filelist :
			print("  Processing file: ", mytext.getFileNameHead(file_xml_en, 'trl'))
			# $ po4a-translate -f xml -M 'UTF-8' -m orig.xml -p list_trans.po -k 0 > trans.xml
			sys_head="po4a-translate -f xml "
			sys_xml=" -M \'UTF-8\' -m \'" + file_xml_en + "\'"
			sys_po=" -p \'" + file_po + "\'"
			sys_out=" -k 0 > \'" + file_xml_trans + "\'"
			sys_sum=sys_head + sys_xml + sys_po + sys_out
			os.system(sys_sum)
		print("\tFinished!")
		print("\tTotal files processed: " , len(filelist) )
		print("-------------------------------------------------")
	
	def distr_lp_po(self, folder_lp_po, folder_target):	# distribution
		_list_lang_short=[]
		_list_table=[]
		_list_file=[]
		
		sys_my=SystemMy()
		
		# get list of files
		for (parent,dirnames,filenames) in os.walk(folder_lp_po):
			for filename in filenames:

				(fn_root, fn_ext)=os.path.splitext(filename)
				if fn_ext=='.po' :
					(str_table, str_lang_short)=fn_root.split('-')
					str_lang_mid=sys_my.getLangCountryName(str_lang_short)
					
					_list_file.append([str_lang_short,str_lang_mid, str_table, os.path.join(parent,filename)])
					if not (str_lang_short in _list_lang_short ):
						_list_lang_short.append(str_lang_short)
		
		# create language folder
		for str_lang_short in _list_lang_short:
			
			str_lang_mid=sys_my.getLangCountryName(str_lang_short)
			print('\tCheck & create folder for Language:', str_lang_short, '\t', str_lang_mid)
			str_path=os.path.join(folder_target, str_lang_mid)
			
			if not os.path.isdir(str_path):
				os.mkdir(str_path)
				
		_list_file.sort()
		
		# copy to language folder
		for (str_lang_short,str_lang_mid, str_table, str_path) in _list_file:
			fn_target= str_table + '_' + str_lang_mid + '.po'
			path_target=os.path.join(folder_target, str_lang_mid,fn_target)

			shutil.copy(str_path, path_target)

class TextMy:

	def isTranslation(self, s_text_ori, s_text_tra, s_text_tra_original = None):
		# Check whether the text is a translation
		# s_text_tra_original is designed for western languages like German.  str_method == 'compare'
		
		if ( (s_text_ori == None) or (s_text_tra == None )) :	# None
			return False
		elif ( (s_text_ori == '') or (s_text_tra == '' ) ) :	# empty
			return False
			
		
		sysmy=SystemMy()
		str_method = sysmy.getMethodDefault()
		str_pattern = sysmy.getPatternDefault()
		
		if (str_method == 'pattern') :	# pattern is a best way for asian languages.
			if ( LANGUAGE_PATTERN_DEFAULT == None  ):
				return False
			elif ( LANGUAGE_PATTERN_DEFAULT == '' ):
				return False
			elif len(re.findall(LANGUAGE_PATTERN_DEFAULT,s_text_tra))>=1:
				return True
		elif (str_method == 'compare') : # compare is a best way for European languages.
			if s_text_tra_original == None:
				if s_text_tra != s_text_ori :
					return True
				else:
					return False
			else:
				if (s_text_tra != s_text_ori) and (s_text_tra != s_text_tra_original ):
					return True
				else:
					return False
		else:
			print('\tError! Wrong type in TextMy.isTranslation(): ', str_method)
			return False
			
	def transScore(self, stext):
		# evaluate the score of translations.
		# it works well for Chinese. but it doesn't work well for German.
		# if you want to do it for German, you have to figure out a new approach.
		if stext == None:
			return 0
		elif stext.strip() == '':
			return 0
		
		if (LANGUAGE_PATTERN_DEFAULT == None) or (LANGUAGE_PATTERN_DEFAULT == ''):
			return 0
			
		ilen_tra=len(re.findall(LANGUAGE_PATTERN_DEFAULT, stext))
		ilen_en=len(re.findall('[a-zA-Z]', stext))
		i_sum=ilen_tra + ilen_en
		if ((i_sum == 0) or (ilen_tra == 0)):
			return 0
		else:
			# i_score= ilen_tra / i_sum * math.log(ilen_tra)	# don't divide by 0
			i_score= ilen_tra / i_sum	# don't divide by 0
			return i_score
	
	def getFileNameHead(self, filename, stype):
		# get head file name. replace
		# e.g. 'en_US/PP_Product_BOMLine_Trl_en_US.xml' --> 'PP_Product_BOMLine_Trl'
		if ( stype=='trl' ):
			list_sub=[[ '_[tT][rR][lL]_[eE][nN]_[uU][sS].*', '_Trl']]
		elif ( stype=='zh'):
			list_sub=[[ 'zh_CN_', '']]
		elif ( stype=='table' ):
			list_sub=[[ '_[tT][rR][lL]_[eE][nN]_[uU][sS].*', ''], ['_[tT][rR][lL].*', '' ]]
		else:
			print('\tError! Wrong type in getFileNameHead! ', stype)
			return False
			
		filelist=[]
		f1_name=os.path.split(filename)[1]		# get file name 
		(f1_name_1, f1_name_2)=os.path.splitext(f1_name)	# split file name

		if ( len(list_sub)==0 ):
			f2_name_head=f1_name_1
		else:
			for [sub1, sub2] in list_sub:
				f2_name_head=re.sub(sub1, sub2, f1_name_1)
		
		return f2_name_head

	
def run_get_pot( folder_in,  folder_out):
	# generate POT file from en_US xml files
	# This function requires po4a pre-installed.
	# On version 0.97, no need of XML4PO, so remove 'filexml4po.getFolder4POXML(folder_in, folder_4po)'
	
	folder_pot_tmp=folder_out + '_tmp'
	myfolder=FolderMy()
	# step 1: en_US  -->  pot_tmp
	toolpo=ToolPO
	toolpo.getPOT(folder_in, folder_pot_tmp)
	
	# step 2: en_US  -->  pot_remark.xml
	file_pot_remark = FileXMLPOTRemark()
	file_pot_remark.getFile_POT_Remark( folder_in )
			
	# step 3: pot_tmp --> pot
	filepo=FilePO()
	filepo.runPOT2POT(folder_pot_tmp, folder_out)
	
	# step 4: check format
	toolpo=ToolPO()
	toolpo.msgfmt(folder_out)
	
def run_get_xml( folder_xml_en_input, folder_po_input, folder_xml_trans_output, str_lang=''):
	
	# XML-AD en_US + po zh_CN  -->  XML-AD zh_CN
	# This function requires po4a pre-installed.
	# folder_in
	# getXML(self, folder_xml_en_input, folder_po_input, folder_xml_trans_output)
	print('----------------------------------------------')
	print('\tGet translated XML files from translated PO files.')
	print('----------------------------------------------')
	# Step 1.
	print('-------\tStep 1 ---------')
	folder_xml_trans_tmp=folder_xml_trans_output + '_tmp'
	toolpo=ToolPO()
	toolpo.getXML(folder_xml_en_input, folder_po_input, folder_xml_trans_tmp, str_lang)
	
	# Step 2.
	#  Replace language="en_US" with language="zh_CN"
	print('-------\tStep 2 ---------')
	filemy=FileMy()
	filemy.replaceTextFolder(folder_xml_trans_tmp, folder_xml_trans_output, str_lang)
	
	shutil.rmtree(folder_xml_trans_tmp)
	
	print('\t--get-xml Finished')

def run_get_xml_simple( folder_xml_en_input, file_po_input, folder_xml_trans_output, str_lang=''):
	
	# XML-AD en_US + po zh_CN  -->  XML-AD zh_CN
	# This function requires po4a pre-installed.
	# folder_in
	# getXML(self, folder_xml_en_input, folder_po_input, folder_xml_trans_output)
	print('----------------------------------------------')
	print('\tGet translated XML files from translated PO files.')
	print('----------------------------------------------')
	# Step 1.
	print('-------\tStep 1 ---------')
	folder_xml_trans_tmp=folder_xml_trans_output + '_tmp'
	toolpo=ToolPO()
	toolpo.getXML_simple(folder_xml_en_input, file_po_input, folder_xml_trans_tmp, str_lang)
	
	# Step 2.
	#  Replace language="en_US" with language="zh_CN"
	print('-------\tStep 2 ---------')
	filemy=FileMy()
	filemy.replaceTextFolder(folder_xml_trans_tmp, folder_xml_trans_output, str_lang)
	
	shutil.rmtree(folder_xml_trans_tmp)
	
	print('\t--get-xml Finished')
	
def run_get_xml_lp( folder_xml_en_input, folder_po_lp, folder_xml):
	
	# batch converting language in lp.net package "launchpad-export" to xml
	print('+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++')
	print('\t--get-xml-lp')
	print('\tGet translated XML files from translated PO files.')
	print('\tBatch processing: launchpad-export package.')
	print('+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++')
	
	toolpo=ToolPO()
	
	folder_po_lp_tmp=folder_po_lp + '_tmp'
	if not os.path.isdir(folder_po_lp_tmp):
		os.mkdir(folder_po_lp_tmp)
		
	if not os.path.isdir(folder_xml):
		os.mkdir(folder_xml)
		
	toolpo.distr_lp_po( folder_po_lp ,folder_po_lp_tmp)

	for (parent,dirnames,filenames) in os.walk(folder_po_lp_tmp):
		for dirname in dirnames:
			str_lang=dirname
			path_source= os.path.join(parent, dirname)
			path_target=os.path.join(folder_xml, str_lang)
			run_get_xml(folder_xml_en_input, path_source, path_target, str_lang)
	print('+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++')
	
def run_lp_package( folder_in, folder_out, stype):
	# make launchpad package for upload
	# step 1: check folder
	
	print('-------------------------------------------')
	print('\tCreating packages for launchpad.net')
	print('-------------------------------------------')
	if stype=='po':
		stype_intern='lp-pkg-po'
	elif stype=='pot':
		stype_intern='lp-pkg-pot'
	else:
		print('\tError! Wrong type in run_lp_package', stype)
		return False
	
	folder_my=FolderMy()
	filelist=folder_my.getFileList2(folder_in, folder_out, stype_intern)
	if filelist == False:
		print('\tErrors found. Please check and try again.')
		return False
	try:
		for (f1, f2) in filelist:
			
			f1_name=os.path.split(f1)[1]
			f1_name_head=os.path.splitext(f1_name)[0]
			
			print('  Processing : ', f1_name_head)
			
			f2_dir=os.path.split(f2)[0]
			os.mkdir(f2_dir)
			shutil.copy( f1 , f2 )

	except Exception as inst: # Check whether the file_in is existing
		print( "Unexpected error while processing files from folder %s: %s" % (folder_in, inst))
		return False
	
	print("  Result: Total files: ", len(filelist))
	print("----------------------------------------")
	return True

def run_msgfmt( folder ):	
	toolpo=ToolPO()
	toolpo.msgfmt(folder)
	
def run_version():
	# version
	sys_my=SystemMy()
	print(sys_my.getVersion())
	return

def run_help():
	sys_my=SystemMy()
	print(sys_my.getHelp())	
			
def run_get_po( file_list_trans, folder_pot, folder_po, filetype='xml'):
	# get translated PO file.
	# po4a-gettextize -f xml -m en1.xml -M 'UTF-8' -l zh1.xml -L 'UTF-8' -p zh1.po
	# file_list_trans. format: xml or po
	# Part 1: Check folder
	print("-------------------------------------------------")
	print("\tGet translated PO files.")
	print("\tlist_trans.xml & *.POT  -->  *.PO")
	print("-------------------------------------------------")
	
	toolPO = ToolPO()
	
	if filetype == 'xml':
		file_list_tmp_en = 'list_tmp_en_US.xml'
		file_list_tmp_tra = 'list_tmp_' + LANGUAGE_DEFAULT + '.xml'
		
		file_list_tmp_po = 'list_trans_tmp.po'
		# step 1. list_trans.xml ->  list_tmp_en_US.xml  &  list_tmp_zh_CN.xml
		file_xml_list=FileXMLList()
		file_xml_list.write(file_list_trans, file_list_tmp_en, file_list_tmp_tra)
		# step 2. list_tmp_en_US.xml  &  list_tmp_zh_CN.xml  -> list_trans_tmp.po
		toolPO.getPO_Trans(file_list_tmp_en, file_list_tmp_tra, file_list_tmp_po)
	elif filetype == 'po':
		file_list_tmp_po=file_list_trans
	else:
		print('\tError! Wrong type in run_get_po!', filetype)
		return False
		
	# step 3.  list_trans_tmp.po  &   AD_Column_Trl.pot  ->  AD_Column.po
	filepo=FilePO()
	filepo.runPO_Upd_Folder(file_list_tmp_po, folder_pot, folder_po)
	
	# step 4: check format
	toolPO.msgfmt(folder_po)
	
	return True

def main():
	import sys
	argv_l=len(sys.argv)
	# print("argv 2:[%s].  argv 3:[%s].  argv 4:[%s]" % ( sys.argv[2], sys.argv[3], sys.argv[4]))
	if argv_l < 2 :  
		print('\tWarning! No action specified.')
		sys.exit()
	if sys.argv[1].startswith('--'):  
		option = sys.argv[1][2:]  # fetch sys.argv[1] but without the first two characters 
		if option=='get-list-trans':
			if argv_l != 5:
				print("Wrong parameters. Example:\n --get-list-trans 'en_US' 'zh_CN' 'list_trans.xml'")
				sys.exit()
			else:
				run_get_list_trans( sys.argv[2], sys.argv[3], sys.argv[4])
		elif option=='get-po':
			if argv_l == 5:
				run_get_po( sys.argv[2], sys.argv[3], sys.argv[4], 'xml')
			elif argv_l == 6:
				run_get_po( sys.argv[2], sys.argv[3], sys.argv[4], sys.argv[5])
			else:
				print("Wrong parameters. Example:\n --get-po 'list_trans.xml' 'pot' 'po' \n --get-po 'list_trans.xml' 'pot' 'po' 'xml'")
				sys.exit()
		elif option=='get-pot':
			if argv_l != 4:
				print("Wrong parameters. Example:\n --get-pot 'en_US' 'pot\'")
				sys.exit()
			else:
				run_get_pot( sys.argv[2], sys.argv[3])
		elif option=='get-xml':
			if argv_l != 5:
				print("Wrong parameters. Example:\n --get-xml 'en_US' 'po_zh_CN' 'xml_zh_CN' ")
				sys.exit()
			else:
				run_get_xml( sys.argv[2], sys.argv[3], sys.argv[4])
		elif option=='get-xml-lp':
			if argv_l != 5:
				print("Wrong parameters. Example:\n --get-xml-lp 'en_US' 'launchpad-export' 'xml' ")
				sys.exit()
			else:
				run_get_xml_lp( sys.argv[2], sys.argv[3], sys.argv[4])
		elif option=='lp-package':
			if argv_l != 5:
				print("Wrong parameters. Example:\n --lp-package 'po-zh_CN'  'pot-zh_CN-lp' 'po'")
				sys.exit()
			else:
				run_lp_package( sys.argv[2],  sys.argv[3], sys.argv[4])
		elif option=='msgfmt':
			if argv_l != 3:
				print("Wrong parameters. Example:\n --msgfmt 'pot'")
				sys.exit()
			else:
				run_msgfmt( sys.argv[2])
		elif option=='reset-lang':
			if argv_l != 6:
				print("Wrong parameters. Example:\n --reset-lang 'zh_CN' 'zh_CN_reset' 'en_US' 'zh_CN'")
				sys.exit()
			else:
				run_reset_lang(sys.argv[2],  sys.argv[3], sys.argv[4], sys.argv[5])
		elif option=='po-merge':
			if argv_l != 4:
				print("Wrong parameters. Example:\n --po-merge 'po-pool' 'list_trans.po'")
				sys.exit()
			else:
				run_po_merge(sys.argv[2],  sys.argv[3])
		elif option=='tidy-xml':
			if argv_l != 4:
				print("Wrong parameters. Example:\n --tidy-xml 'en_US' 'en_US_tidy'")
				sys.exit()
			else:
				run_tidy_xml(sys.argv[2],  sys.argv[3])
		elif option == 'version':  
			run_version()
		elif option == 'help': 
			run_help()
		elif option == 'test': 
			run_test()
		else:  
			print( '\tWarning! Unknown option.'  )
			sys.exit()  
	else:
		print( '\tWarning! Unknown option.'  )
		sys.exit()  

def run_get_list_trans(mode, file_out, folder_tra,  folder_ori=''):
	# get 'list_trans.xml'
	'''
	About mode
	mode 1: pair.
		get translation list from a pair of files. e.g.
		from AD_Column_Trl_en_US.xml, get original text.  		<value>Table</value>
		from AD_Column_Trl_zh_CN.xml, get translation text. 	<value>表</value>
	mode 2: single
		get translation list within a file. e.g.
		1 line in AD_Column_Trl_zh_CN.xml:
			<value column="Name" original="Table">表</value>
		from original="Table", get original text.
		from <value>表</value>, get translation text.
		
	mode 1 is very useful when the translation XML file is:
		not maintained well;
		not from the latest version.
		... 
	'''
	
	listmy=ListMy()
	foldermy=FolderMy()
	elem_my=ElementMy()
	
	myfolder=FolderMy()
	
	if mode not in ['pair', 'single']:
		print('\tError! Wrong mode in run_get_list_trans!')
		print('\tmode:\t', mode)
		return False
	
	if mode=='pair':
		print('-------------------------------------------------------')
		print('\tGet list_trans.xml from XML-4PO ( en_US & local )')
		print('-------------------------------------------------------')
		# attention: base on XML-AD format
		filelist=foldermy.getMatchFileList(folder_ori, folder_tra, 'xml')
		for [file_ori, file_tra] in filelist:
			elem_my.readItemList2(file_ori, file_tra)
			# elem_my.getListTrans_Original() is specially designed for western languages like German.
			listmy.addList(elem_my.getListOrigin(), elem_my.getListTrans(), elem_my.getListTrans_Original())
	
	elif mode=='single':
		print('-------------------------------------------------------')
		print('\tGet list_trans.xml from XML-4PO ( en_US & local )')
		print('-------------------------------------------------------')
		filelist=foldermy.getFileList1(folder_tra, 'xml')
		for file_tra in filelist:
			elem_my.readItemList1(file_tra, 'XML-AD')
			listmy.addList(elem_my.getListOrigin(), elem_my.getListTrans(), elem_my.getListTrans_Original())

	listmy.reorganize()
	listmy.write(file_out)
	print('\tFinished!')
	print('-------------------------------------------------------')
	
	return True
	
def run_get_list_trans_single( folder_tra, file_out):
	# this is testing
	# for a single file
	# get origin & translation from one file
	# get 'list_trans.xml'
	
	listmy=ListMy()
	foldermy=FolderMy()
	elem_my=ElementMy()
	
	myfolder=FolderMy()

	
	print('-------------------------------------------------------')
	print('\tGet list_trans.xml from XML-4PO ( en_US & local )')
	print('-------------------------------------------------------')
	# attention: base on XML-AD format
	filelist=foldermy.getFileList1(folder_tra, 'xml')
	# print(filelist)
	for file_tra in filelist:
		elem_my.readItemList1(file_tra, 'XML-AD')
		# elem_my.getListTrans_Original() is specially designed for western languages like German.
		listmy.addList(elem_my.getListOrigin(), elem_my.getListTrans(), elem_my.getListTrans_Original())

	listmy.reorganize()
	listmy.write(file_out)
	print('\tFinished!')
	print('-------------------------------------------------------')
	
	return True
	
def run_get_list_trans_combine( list_sourcefile, list_sourcemark, file_out):
	# this is testing
	# for a single file
	# get origin & translation from one file
	# get 'list_trans.xml'
	
	listmy=ListMy()
	elem_my=ElementMy()
	
	print('-------------------------------------------------------')
	print('\tGet list_trans.xml from XML-4PO ( en_US & local )')
	print('-------------------------------------------------------')
	# attention: base on XML-LST-MIX format

	ilen=len(list_sourcefile)
	if ( ilen != len(list_sourcemark)):
		print('\tError! len(list_sourcefile) != len(list_sourcemark)' )
		return False
	
	for i in range(ilen):
		
		elem_my.readItemList1(list_sourcefile[i], 'XML-LST-MIX-ALL')
		# elem_my.getListTrans_Original() is specially designed for western languages like German.
		listmy.addList(elem_my.getListOrigin(), elem_my.getListTrans(), elem_my.getListTrans_Original(), list_sourcemark[i])

	listmy.reorganize()
	listmy.write(file_out)
	print('\tFinished!')
	print('-------------------------------------------------------')
	
	return True
	
	
def run_get_list_trans_retidy( sourcefile,  file_out):
	# this is testing
	# for a single file
	# get origin & translation from one file
	# get 'list_trans.xml'
	
	listmy=ListMy()
	elem_my=ElementMy()
	
	print('-------------------------------------------------------')
	print('\tGet list_trans.xml from XML-4PO ( en_US & local )')
	print('-------------------------------------------------------')
	# attention: base on XML-LST-MIX format
	
	elem_my.readItemList1(sourcefile, 'XML-LST-MIX')
		
	listmy.addList(elem_my.getListOrigin(), elem_my.getListTrans(), elem_my.getListTrans_Original())

	listmy.reorganize()
	listmy.write(file_out)
	print('\tFinished!')
	print('-------------------------------------------------------')
	
	return True

def run_reset_lang(folder_in, folder_out, lan_origin, lan_replace):
	# filexml.resetLanguage('zh_CN', 'zh_CN_reset' , 'zh_CN', 'es_AR')
	filexml=FileXML
	print(folder_in, folder_out, lan_origin, lan_replace)
	filexml.resetLanguage(folder_in, folder_out, lan_origin, lan_replace)

def run_po_merge( folder_po, file_po_output):
	# merge all the po files in the folder.
	# normally for po format packages downloaded from launchpad.net
	filepo=FilePO()
	filepo.runPO_Merge(folder_po, file_po_output)

def run_tidy_xml( folder_in, folder_out ):
	# tidy the format of XML-AD. 
	# This function is especially for <![CDATA[&Menu]]>
	filexml=FileXML()
	filexml.tidyFolder(folder_in, folder_out)
	
def run_test():
	# this function is only for testing
	print('-------------------------------------------------------')
	print('\tThis is testing.')
	

	'''
	fd_en="/home/peanut/workspace/tool4po/run/en_US_360"
	fd_zh_01="/home/peanut/workspace/tool4po/run/zh_CN_ad360"
	fl_list_trans_01="/home/peanut/workspace/tool4po/run/trans-list-zh-ad360.xml"
	# run_get_list_trans(fd_en, fd_zh_01, fl_list_trans_01)
	
	fd_zh_02="/home/peanut/workspace/tool4po/run/zh_CN_ad330"
	fl_list_trans_02="/home/peanut/workspace/tool4po/run/trans-list-zh-ad330.xml"
	# run_test_get_list_trans(fd_zh_02, fl_list_trans_02)
	
	fd_zh_03="/home/peanut/workspace/tool4po/run/zh_CN_cm330"
	fl_list_trans_03="/home/peanut/workspace/tool4po/run/trans-list-zh-cm330.xml"
	# run_test_get_list_trans(fd_zh_03, fl_list_trans_03)
	
	list_sourcefile=["/home/peanut/workspace/tool4po/run/trans-list-zh-ad360.xml","/home/peanut/workspace/tool4po/run/trans-list-zh-ad330.xml","/home/peanut/workspace/tool4po/run/trans-list-zh-cm330.xml"]
	list_sourcemark=['ad360', 'ad330', 'cm330']
	fl_list_trans_04="/home/peanut/workspace/tool4po/run/trans-list-zh-all-combine-score-03.xml"
	# run_get_list_trans_combine(list_sourcefile,list_sourcemark, fl_list_trans_04)
	
	sourcefile_06="/home/peanut/workspace/tool4po/run/trans-list-zh-all-combine-3rd-merge.xml"
	fl_list_trans_06="/home/peanut/workspace/tool4po/run/trans-list-zh-all-06-retidy.xml"
	# run_get_list_trans_retidy( sourcefile_06, fl_list_trans_06)
	
	sourcefile_07="/home/peanut/workspace/tool4po/run/trans-list-zh-all-06-retidy.xml"
	fl_list_trans_07="/home/peanut/workspace/tool4po/run/trans-list-zh-all-07-retidy.xml"
	# run_get_list_trans_retidy( sourcefile_07, fl_list_trans_07)
	
	
	pot='/home/peanut/workspace/tool4po/run/en_US_360LTS_pot'
	# run_get_pot(en_us, pot)

	po_1="/home/peanut/workspace/tool4po/run/trans-list-zh-all-07-retidy.xml"
	po_2="/home/peanut/workspace/tool4po/run/en_US_360LTS_pot"
	po_3="/home/peanut/workspace/tool4po/run/zh_08_po"
	'''
	# run_get_po(po_1, po_2, po_3)
	
	en_us='/home/peanut/workspace/tool4po/run/en_US_360LTS_standard'
	po_1c="/home/peanut/workspace/tool4po/run/51_zh_CN_translate_improve/list_trans_zh-CN-edit.po"
	po_2="/home/peanut/workspace/tool4po/run/en_US_360LTS_pot"
	po_3="/home/peanut/workspace/tool4po/run/zh_13_po"
	#run_get_po(po_1c, po_2, po_3, 'po')
	
	fd_xml_a="/home/peanut/workspace/tool4po/run/zh_13a_xml"
	#run_get_xml(en_us, po_3, fd_xml_a)

	fd_xml_b="/home/peanut/workspace/tool4po/run/zh_15b_xml"
	run_get_xml_simple(en_us, po_1c, fd_xml_b )
	
	

	# merge or resort po
	po_from="/home/peanut/workspace/tool4po/run/po-resort/"
	po_to="/home/peanut/workspace/tool4po/run/po-resort-01.po"
	# run_po_merge(po_from, po_to)

	
	#fd_zh_simple="/home/peanut/workspace/tool4po/run/zh_CN_simple"
	#fl_list_trans_01="/home/peanut/workspace/tool4po/run/trans-list-zh-01.xml"
	#fl_list_trans_03="/home/peanut/workspace/tool4po/run/trans-list-zh-03-simple.xml"
	# run_get_list_trans(fd_en, fd_zh, fl_list_trans)
	# run_get_list_trans(fd_en, fd_zh_simple, fl_list_trans_03)
	
	#fl_list_trans_11="/home/peanut/workspace/tool4po/run/trans-list-compiere-11.xml"
	#fd_com="/home/peanut/workspace/tool4po/run/compiere"
	# run_test_get_list_trans(fd_com, fl_list_trans_11)

if __name__ == '__main__':
	initial()
	main()
